﻿//-----------------------------------------------------------------------
// <author email="wen.haixiong@live.com" blog="http://www.cnblogs.com/cesium/">温海雄</author>
//-----------------------------------------------------------------------
namespace OpenSesame
{
    using System;

    [Serializable]
    public class IfElse : CompositeProgramStatement
    {
        public IfElse(BooleanExpression expression)
        {
            Expression = expression;
        }

        public BooleanExpression Expression
        {
            get;
            private set;
        }

        internal override void Run(BookmarkManager mgr)
        {
            State = ProgramState.Running;
            if (Expression.Evaluate())
                mgr.RunProgramStatement(Statements[0], ContinueAt);
            else if ((Statements.Count > 2) && (Statements[1] != null))
                mgr.RunProgramStatement(Statements[1], ContinueAt);
            else
                State = ProgramState.Done;
        }

        public void ContinueAt(Bookmark resumed)
        {
            State = ProgramState.Done;
        }
    }
}
