﻿//-----------------------------------------------------------------------
// <author email="wen.haixiong@live.com" blog="http://www.cnblogs.com/cesium/">温海雄</author>
//-----------------------------------------------------------------------
namespace OpenSesame
{
    using System;
    using System.Collections.Generic;

    public class MythicalRuntime
    {
        private Dictionary<Guid, ProgramHandle> m_Programs = new Dictionary<Guid, ProgramHandle>();

        public MythicalRuntime()
        {
            foreach (var item in DbHelper.GetProgramHandles())
            {
                m_Programs.Add(item.ProgramId, item);
            }
        }

        public ProgramHandle RunProgram(Guid programId, ProgramStatement program)
        {
            var handle = new ProgramHandle(programId);
            handle.Statement = program;
            m_Programs.Add(handle.ProgramId, handle);
            program.Run(handle.BookmarkManager);
            return handle;
        }

        public ProgramHandle GetProgramHandle(Guid programId)
        {
            if (m_Programs.ContainsKey(programId))
                return m_Programs[programId];

            return null;
        }

        public void Shutdown()
        {
            foreach (var item in m_Programs)
            {
                item.Value.Passivate();
            }
        }
    }
}
