﻿//-----------------------------------------------------------------------
// <author email="wen.haixiong@live.com" blog="http://www.cnblogs.com/cesium/">温海雄</author>
//-----------------------------------------------------------------------
namespace OpenSesame
{
    using System;
    using System.IO;

    [Serializable]
    public class ProgramHandle
    {
        public ProgramHandle() : this(Guid.NewGuid())
        { }

        public ProgramHandle(Guid id)
        {
            BookmarkManager = new BookmarkManager();
            ProgramId = id;
        }

        public Guid ProgramId
        {
            get;
            set;
        }

        public ProgramStatement Statement
        {
            get;
            set;
        }

        public BookmarkManager BookmarkManager
        {
            get;
            set;
        }

        public ProgramState State
        {
            get
            {
                return Statement.State;
            }
        }

        public void Passivate()
        {
            if (Statement == null)
                throw new InvalidOperationException("Statement不能为null");

            switch (State)
            {
                case ProgramState.Latent:
                case ProgramState.Running:
                    Utility.Serialize(this, ProgramId.ToString() + ".sf");
                    DbHelper.UpdateProgramHandle(this);
                    break;
                case ProgramState.Done:
                    DbHelper.DeleteProgramHandle(this);
                    File.Delete(ProgramId.ToString() + ".sf");
                    break;
                default:
                    break;
            }
            
        }

        public void Resume(string bookmarkName, object payload)
        {
            BookmarkManager.Resume(bookmarkName, payload);
        }
    }
}
