﻿//-----------------------------------------------------------------------
// <author email="wen.haixiong@live.com" blog="http://www.cnblogs.com/cesium/">温海雄</author>
//-----------------------------------------------------------------------
namespace OpenSesame
{
    using System;

    [Serializable]
    public class ProgramStatementBlock : CompositeProgramStatement
    {
        public int CurrentIndex
        {
            get;
            private set;
        }

        internal override void Run(BookmarkManager mgr)
        {
            State = ProgramState.Running;
            CurrentIndex = 0;

            if (Statements.Count > 0)
                mgr.RunProgramStatement(Statements[0], ContinueAt);
            else
                State = ProgramState.Done;
        }

        public void ContinueAt(Bookmark resumed)
        {
            if (++CurrentIndex < Statements.Count)
                resumed.BookmarkManager.RunProgramStatement(Statements[CurrentIndex], ContinueAt);
            else
                State = ProgramState.Done;
        }
    }
}
