﻿//-----------------------------------------------------------------------
// <author email="wen.haixiong@live.com" blog="http://www.cnblogs.com/cesium/">温海雄</author>
//-----------------------------------------------------------------------
namespace OpenSesame
{
    using System;
    using System.IO;
    using System.Runtime.Serialization.Formatters.Binary;

    /// <summary>
    /// 工具类。
    /// </summary>
    internal static class Utility
    {
        //private static Type[] _KnownTypes = new Type[] { typeof(OpenSesame) };

        /// <summary>
        /// 尝试从字符串中解析一个<see cref="Guid"/>实例对象。
        /// </summary>
        /// <param name="guidString">可能包含Guid的字符串。</param>
        /// <param name="guid">解析出的<see cref="Guid"/>实例对象。</param>
        /// <returns>解析成功返回true，否则返回false。</returns>
        internal static bool TryParseGuid(string guidString, out Guid guid)
        {
            try
            {
                guid = new Guid(guidString);
                return true;
            }
            catch
            {
                guid = Guid.Empty;
                return false;
            }
        }

        //internal static string WriteObject(object obj)
        //{
        //    if (obj == null)
        //        throw new ArgumentNullException("obj");

        //    MemoryStream stream = new MemoryStream();
        //    DataContractSerializer serializer = new DataContractSerializer(obj.GetType(), _KnownTypes);
        //    serializer.WriteObject(stream, obj);
        //    var result = Encoding.UTF8.GetString(stream.ToArray());
        //    return result;
        //}

        //internal static T ReadObject<T>(string xml)
        //{
        //    if (xml == null)
        //        throw new ArgumentNullException("xml");

        //    DataContractSerializer serializer = new DataContractSerializer(typeof(T), _KnownTypes);
        //    var obj = serializer.ReadObject(new MemoryStream(Encoding.UTF8.GetBytes(xml)));
        //    return (T)obj;
        //}

        internal static void Serialize(object obj, string fileName)
        {
            if (obj == null)
                throw new ArgumentNullException("obj");
            if (string.IsNullOrEmpty(fileName))
                throw new ArgumentNullException("fileName");

            var stream = File.OpenWrite(fileName);
            BinaryFormatter formatter = new BinaryFormatter();
            formatter.Serialize(stream, obj);
            stream.Close();
        }

        internal static T Deserialize<T>(string fileName)
        {
            if (fileName == null)
                throw new ArgumentNullException("fileName");

            BinaryFormatter formatter = new BinaryFormatter();
            var stream = File.OpenRead(fileName);
            var obj = formatter.Deserialize(stream);
            stream.Close();
            return (T)obj;
        }
    }
}
